Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 854831 - app-office/lyx-2.3.6.1-r2 fails to compile (lto): client.cpp:73:8: error: type [-Werror=odr]
Summary: app-office/lyx-2.3.6.1-r2 fails to compile (lto): client.cpp:73:8: error: typ...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Arthur Zamarin
URL: https://www.mail-archive.com/lyx-deve...
Whiteboard:
Keywords:
Depends on: 931686
Blocks: lto
  Show dependency tree
 
Reported: 2022-06-28 10:46 UTC by Agostino Sarubbo
Modified: 2024-07-04 18:36 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,439.27 KB, text/plain)
2022-06-28 10:46 UTC, Agostino Sarubbo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2022-06-28 10:46:24 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: app-office/lyx-2.3.6.1-r2 fails to compile (lto).
Discovered on: amd64 (internal ref: lto_tinderbox)

NOTE:
This machine uses lto with CFLAGS=-flto -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing
Comment 1 Agostino Sarubbo gentoo-dev 2022-06-28 10:46:27 UTC
Created attachment 788360 [details]
build.log

build log and emerge --info
Comment 2 Agostino Sarubbo gentoo-dev 2022-07-26 09:00:26 UTC
Here is a bit of explanation:

-Werror=lto-type-mismatch:
User to find possible runtime issues in packages. It likely means the package is unsafe to build & use with LTO.
For projects using the same identifier but with different types across different files, they must be fixed to be consistent across the codebase.

-Werror=odr:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO. C++ code must comply with the One Definition Rule (ODR) - see https://en.cppreference.com/w/cpp/language/definition#One_Definition_Rule.

-Werror=strict-aliasing:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO.

Workarounds:
- If upstream is friendly and still active, file a bug upstream. For emulators, codecs, games, or multimedia packages, it may be worth just applying a workaround instead, as upstreams sometimes aren't receptive to these bugs (VALID FOR ALL).
- Use the new 'filter-lto' from flag-o-matic.eclass as it's likely to be unsafe with LTO (VALID FOR lto-type-mismatch - odr).
- Fix it yourself if interested, of course (VALID FOR ALL).
- Append-flags -fno-strict-aliasing (VALID FOR strict-aliasing).
- Use memcpy() but a union is sometimes suitable too (VALID FOR strict-aliasing).
- -fstrict-aliasing is implied by -O2, so this must be addressed in some form (VALID FOR strict-aliasing).

See also: https://marc.info/?l=gentoo-dev&m=165639574126280&w=2
Comment 3 Arthur Zamarin archtester Gentoo Infrastructure gentoo-dev Security 2024-04-05 13:44:57 UTC
Should be fixed in 2.4.0_rc4 which I just pushed. I'll wait to close the bug when we stabilize it instead.
Comment 4 Larry the Git Cow gentoo-dev 2024-07-04 18:36:28 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ea3b767e18f7e464ca3807878d3fefb0fe53f6d9

commit ea3b767e18f7e464ca3807878d3fefb0fe53f6d9
Author:     Arthur Zamarin <arthurzam@gentoo.org>
AuthorDate: 2024-07-04 17:19:19 +0000
Commit:     Arthur Zamarin <arthurzam@gentoo.org>
CommitDate: 2024-07-04 18:36:18 +0000

    app-office/lyx: drop 2.3.7, 2.4.0_rc4
    
    Closes: https://bugs.gentoo.org/854831
    Closes: https://bugs.gentoo.org/916042
    Signed-off-by: Arthur Zamarin <arthurzam@gentoo.org>

 app-office/lyx/Manifest             |   2 -
 app-office/lyx/lyx-2.3.7.ebuild     | 197 ------------------------------------
 app-office/lyx/lyx-2.4.0_rc4.ebuild | 180 --------------------------------
 3 files changed, 379 deletions(-)